import 'package:cramr_ui_lib/model/study_mode.dart';
import 'package:cramr_ui_lib/model/study_mode_state.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_form_appbar.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_test_route.dart';
import 'package:cramr_ui_lib/theme/custom_theme.dart';
import 'package:cramr_ui_lib/widgets/flash_card_stack.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

/// Screen for studying with flash cards.
class VerbIndicativeStudyFlashcardModeRoute extends StatelessWidget {
  static const routeName = '/verbIndicativeFlashcardModeStudyRoute';

  const VerbIndicativeStudyFlashcardModeRoute({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: "Verbomatique",
      debugShowCheckedModeBanner: false,
      theme: CustomTheme.lightTheme,
      home: Scaffold(
        key: UniqueKey(),
        appBar: VerbIndicativeStudyFormAppbar().asWidget(context),
        body: FlashCardStack(),
        floatingActionButton: Visibility(
          key: const Key('flashcard_forward_button_visibility'),
          child: _toTestRouteButton(context),
        ),
      ),
    );
  }

  Widget _toTestRouteButton(BuildContext context) {
    return FloatingActionButton(
      key: const Key('flashcard_forward_button'),
      child: const Icon(Icons.arrow_forward),
      onPressed: () {
        final StudyModeState studyModeState =
            Provider.of<StudyModeState>(context, listen: false);
        studyModeState.updateState(StudyMode.flashCardMode);
        Navigator.pushNamed(context, VerbIndicativeTestRoute.routeName);
      },
    );
  }
}
