import 'package:cramr_ui_lib/model/study_mode.dart';
import 'package:cramr_ui_lib/model/study_mode_state.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_form_appbar.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_test_route.dart';
import 'package:cramr_ui_lib/theme/custom_theme.dart';
import 'package:cramr_ui_lib/widgets/written_indicative_study_widget.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

/// The screen for studying in write mode.
class VerbIndicativeStudyWriteModeRoute extends StatelessWidget {
  static const routeName = '/verbIndicativeWriteModeStudyRoute';

  const VerbIndicativeStudyWriteModeRoute({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: "Verbomatique",
        debugShowCheckedModeBanner: false,
        theme: CustomTheme.lightTheme,
        home: SafeArea(
          key: UniqueKey(),
          child: Scaffold(
            key: UniqueKey(),
            appBar: VerbIndicativeStudyFormAppbar().asWidget(context),
            body: const WrittenIndicativeStudyWidget(),
            floatingActionButton: _toTestRouteButton(context),
          ),
        ));
  }

  Widget _toTestRouteButton(BuildContext context) {
    return FloatingActionButton(
      key: const Key('write_forward_button'),
      child: const Icon(Icons.arrow_forward),
      onPressed: () {
        final StudyModeState studyModeState =
            Provider.of<StudyModeState>(context, listen: false);
        studyModeState.updateState(StudyMode.writtenMode);
        Navigator.pushNamed(context, VerbIndicativeTestRoute.routeName);
      },
    );
  }
}
